#!/usr/bin/python

#
# ChangePW 1.1
#
# Aendern des Passwortes eines HTTP-Auth-Benutzers
#
# Autor:            Patrick Canterino <patrick@patshaping.de>
# Letzte Aenderung: 29.6.2006
#

### Konfiguration ###

pwfile       = ''
use_md5crypt = 0

### Ende Konfiguration ###

import cgitb; cgitb.enable()

import cgi
import os
import random

import re

# Funktionen

# Funktionen fuer md5crypt
# Entnommen aus md5crypt.py von http://www.sabren.net/code/python/crypt/md5crypt.py

MAGIC = '$1$'			# Magic string
ITOA64 = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

import md5

def to64 (v, n):
    ret = ''
    while (n - 1 >= 0):
        n = n - 1
	ret = ret + ITOA64[v & 0x3f]
	v = v >> 6
    return ret


def apache_md5_crypt (pw, salt):
    # change the Magic string to match the one used by Apache
    return unix_md5_crypt(pw, salt, '$apr1$')


def unix_md5_crypt(pw, salt, magic=None):

    if magic==None:
        magic = MAGIC

    # Take care of the magic string if present
    if salt[:len(magic)] == magic:
        salt = salt[len(magic):]


    # salt can have up to 8 characters:
    import string
    salt = string.split(salt, '$', 1)[0]
    salt = salt[:8]

    ctx = pw + magic + salt

    final = md5.md5(pw + salt + pw).digest()

    for pl in range(len(pw),0,-16):
        if pl > 16:
            ctx = ctx + final[:16]
        else:
            ctx = ctx + final[:pl]


    # Now the 'weird' xform (??)

    i = len(pw)
    while i:
        if i & 1:
            ctx = ctx + chr(0)  #if ($i & 1) { $ctx->add(pack("C", 0)); }
        else:
            ctx = ctx + pw[0]
        i = i >> 1

    final = md5.md5(ctx).digest()

    # The following is supposed to make
    # things run slower.

    # my question: WTF???

    for i in range(1000):
        ctx1 = ''
        if i & 1:
            ctx1 = ctx1 + pw
        else:
            ctx1 = ctx1 + final[:16]

        if i % 3:
            ctx1 = ctx1 + salt

        if i % 7:
            ctx1 = ctx1 + pw

        if i & 1:
            ctx1 = ctx1 + final[:16]
        else:
            ctx1 = ctx1 + pw


        final = md5.md5(ctx1).digest()


    # Final xform

    passwd = ''

    passwd = passwd + to64((int(ord(final[0])) << 16)
                           |(int(ord(final[6])) << 8)
                           |(int(ord(final[12]))),4)

    passwd = passwd + to64((int(ord(final[1])) << 16)
                           |(int(ord(final[7])) << 8)
                           |(int(ord(final[13]))), 4)

    passwd = passwd + to64((int(ord(final[2])) << 16)
                           |(int(ord(final[8])) << 8)
                           |(int(ord(final[14]))), 4)

    passwd = passwd + to64((int(ord(final[3])) << 16)
                           |(int(ord(final[9])) << 8)
                           |(int(ord(final[15]))), 4)

    passwd = passwd + to64((int(ord(final[4])) << 16)
                           |(int(ord(final[10])) << 8)
                           |(int(ord(final[5]))), 4)

    passwd = passwd + to64((int(ord(final[11]))), 2)


    return magic + salt + '$' + passwd


## assign a wrapper function:
md5crypt = unix_md5_crypt

# Ende md5crypt

# Erzeugen eines zufaelligen Salt fuer crypt() bzw. md5crypt

def gen_salt(length=2):
 chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ./'
 max   = len(chars)

 salt  = ''
 x     = 0

 while x<length:
  salt += chars[random.randint(0,max)]
  x += 1

 return salt

# Einlesen der Passwort-Datei ueber einen Datei-Deskriptor

def parse_pwlist(fp):
 passwords = {}
 data = fp.read()

 lines = data.splitlines()

 iscomment = re.compile('^\s*#')
 isvalid   = re.compile('^.+:.*$')

 for line in lines:
  if not iscomment.match(line) and isvalid.match(line):
   parts = line.split(':',1)
   passwords[parts[0]] = parts[1]

 return passwords

# Zurueckschreiben der Passwort-Datei

def write_pwlist(fp,passwords):
 users = passwords.keys()

 # Passwort-Datei zuruecksetzen

 fp.seek(0)
 fp.truncate(0)

 # Benutzer in Datei schreiben

 for user in users:
  fp.write(user+':'+passwords[user]+'\n')

 return 1

# Hauptteil

script = cgi.escape(os.getenv('SCRIPT_NAME'),1)
user   = os.getenv('REMOTE_USER')
form   = cgi.FieldStorage()

print 'Content-type: text/html\n'
print '''<?xml version="1.0" encoding="iso-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Passwort &auml;ndern</title>
</head>
<body>

<h1>Passwort &auml;ndern</h1>
'''

# Pruefen, ob crypt() verfuegbar ist

if not use_md5crypt:
 try:
  import crypt
  use_crypt = 1
 except ImportError:
  use_crypt = 0
else:
 use_crypt = 0

# Pruefen, ob wir flock() nutzen koennen

try:
 import fcntl
 def lock_ex(fp):
  return fcntl.flock(fp,fcntl.LOCK_EX)
except ImportError:
 def lock_ex(fp):
  return 1

# Feststellen, ob Daten eingegeben wurden

if form.has_key('passold') and form.has_key('pass1') and form.has_key('pass2'):
 passold = form['passold'].value
 pass1   = form['pass1'].value
 pass2   = form['pass2'].value

 # Passwoerter auslesen

 fp = open(pwfile,'r+')
 lock_ex(fp)

 passwords = parse_pwlist(fp)

 if passwords.has_key(user):
  password = passwords[user]

  if use_md5crypt:
   # md5crypt nutzen
   salt = password[6:password.find('$',6)]  # "$apr1$" ist 6 Zeichen lang
   passold = apache_md5_crypt(passold,salt)

   new_salt = gen_salt(8)
   pass1 = apache_md5_crypt(pass1,new_salt)
   pass2 = apache_md5_crypt(pass2,new_salt)

  elif use_crypt:
   # crypt() verfuegbar
   salt = password[0:2]
   passold = crypt.crypt(passold,salt)

   new_salt = gen_salt()
   pass1 = crypt.crypt(pass1,new_salt)
   pass2 = crypt.crypt(pass2,new_salt)

  # Eingegebenes Passwort mit dem gespeicherten vergleichen

  if passold == password:
   # Die beiden eingebenen Passwoerter vergleichen
   if pass1 == pass2:
    # Passwort aendern und speichern
    passwords[user] = pass1
    write_pwlist(fp,passwords)

    print '<p>Das Passwort wurde erfolgreich ge&auml;ndert!</p>'
   else:
    print '<p>Die eingegebenen Passw&ouml;rter stimmen nicht &uuml;berein!</p>'
  else:
   print '<p>Das eingegebene Passwort stimmt nicht mit dem gespeicherten &uuml;berein!</p>'

 else:
  print '<p>Der aktuelle Benutzer ('+cgi.escape(user,1)+') ist nicht in der Passwort-Datei vorhanden!</p>'

 fp.close()
else:
 print '''<form action="'''+cgi.escape(script,1)+'''" method="POST">
<table border="0">
<tr>
<td>Benutzer:</td>
<td>'''+cgi.escape(user,1)+'''</td>
</tr>
<tr>
<td>Altes Passwort:</td>
<td><input type="password" name="passold" /></td>
</tr>
<tr>
<td>Neues Passwort:</td>
<td><input type="password" name="pass1" /></td>
</tr>
<tr>
<td>Neues Passwort best&auml;tigen:</td>
<td><input type="password" name="pass2" /></td>
</tr>
</table>

<p><input type="submit" value="Passwort &auml;ndern" /> <input type="reset" value="R&uuml;ckg&auml;ngig" /></p>
</form>'''

print '''</body>
</html>'''

#
### Ende ###